<template>
  <div class="surveys-comp container">
    <h2 class="survey-title">List of surveys</h2>

    <h2 class="surveys-search">
      <input
        type="text"
        class="filter"
        placeholder="Type to filter"
        @input="onChangeFilter"
      />
    </h2>

    <div class="surveys-table">
      <div class="table-header">
        <div class="survey-col">
          <div class="table-item">Name</div>
        </div>
        <div class="survey-col">
          <div class="table-item">Code</div>
        </div>
      </div>
      <div class="table-body">
        <div
          v-for="survey in surveysFilter"
          :key="survey.code"
          :class="`table-row`"
          @click="rowClick(survey.code)"
        >
          <div class="survey-col">
            <div class="table-item">
              {{ survey.name }}
            </div>
          </div>
          <div class="survey-col">
            <div class="table-item">
              {{ survey.code }}
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
export default {
  name: "SurveyList",
  props: {
    surveys: {
      type: Array,
      default: () => [],
    },
  },
  computed: {
    surveysFilter() {
      if (!this.filterText) return this.surveys;
      return this.surveys.filter(
        (survey) =>
          this.matchText(survey.code, this.filterText) ||
          this.matchText(survey.name, this.filterText)
      );
    },
  },
  data() {
    return {
      filterText: "",
    };
  },
  methods: {
    rowClick(code) {
      if (!code) return;
      this.$router.push(`/detail/${code}`);
    },
    onChangeFilter(event) {
      const { value } = event.target;
      this.filterText = value;
    },
    matchText(data, text) {
      return data.toLowerCase().includes(text.toLowerCase());
    },
  },
};
</script>
<style lang="scss">
.survey-title {
  color: $-blue;
  padding-top: 10px;
  padding-bottom: 10px;
}
</style>
<style lang="scss" scoped>
.survey-col {
  width: 50%;
}
.surveys-table {
  max-width: 860px;
  .table-header,
  .table-row {
    display: flex;
  }
  .table-header {
    background-color: $-blue;
    color: $-white;
    font-weight: bold;
  }
  .table-row {
    cursor: pointer;
    &:hover,
    &:focus {
      background-color: $-blue;
      color: $-white;
      opacity: 0.5;
    }
  }
  .table-item {
    padding: 15px 12px;
  }
}
.surveys-search {
  width: 220px;
  padding-bottom: 10px;
  .filter {
    width: 100%;
    height: 40px;
    padding: 10px 12px;
    border: 1px solid $-blue;
    border-radius: 6px;
  }
}
</style>
